/* ---------------------------------------------------------------- */
// 
// guider.h
//
/* ---------------------------------------------------------------- */

#ifndef INCLUDE_GUIDER_H
#define INCLUDE_GUIDER_H

/* ---------------------------------------------------------------- */

#include "qltool.h"
#include "graph.h"
#include "fits.h"

/* ---------------------------------------------------------------- */

typedef struct guider_tag {
  int           num;
  char          name[32];
  FITSpars      status;
  volatile Bool loop_running;
  volatile Bool stop_flag;
  volatile int  write_flag,send_flag,init_flag;
  pthread_t     gid;
  int           pamode,esmode,msmode;
  float         *dark_buf;
  volatile int  sub_mode,display_trigger; // todo display_mutex,display_buf
  /* GUI */
  Window      win;
  QlTool      *qltool;
  GraphWindow *g_az,*g_el,*g_tc,*g_fw;
  EditWindow  tfbox,dtbox;             /* exposure time */
  Menu        gdmenu;                  /* guider options menu */
  EditWindow  fpbox,fdbox,fgbox;       /* frames per second */
  EditWindow  gdbox,tcbox,mxbox,bkbox,fwbox,dxbox,dybox;
  EditWindow  snbox,pxbox,bxbox,pabox,avbox;   /* xf,yf ?Shec */
  EditWindow  gmbox,gabox,fmbox,mmbox; /* ?Shec */
  EditWindow  csbox;                   /* cursor step */
  EditWindow  sqbox;                   /* sequence number */
  EditWindow  tmbox;                   /* temperature */
  EditWindow  cmbox;                   /* command line */
  EditWindow  *msbox;                  /* message window(s) */
  Led         *led;
  /* Andor */
  AndorStruct *andor;
  Bool        stabilized;
  /* Guiding */
  int         shmode,q_flag;
  float       px;                      /* eff. pixscale (incl. binning) */
  double      pa,azerp,elerp,sens,azg,elg;
  pthread_mutex_t mutex;
  volatile Bool update_flag;
  volatile double fps,flux,ppix,back,fwhm,dx,dy;
  char        send_host[128];
  int         send_port;
} Guider;

/* ---------------------------------------------------------------- */

#endif /* INCLUDE_GUIDER_H */

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */

